/*Template Proiect AEMC - ETTI Iasi*/
#include <xc.h>
#include <string.h>

#define LED1 RB0 
#define LED2 RB1

char *logo  = (char *) "AEMC - proiect";
char *logo1 = (char *) "linia_1";
char *logo2 = (char *) "linia_2";
char *logo3 = (char *) "linia_3";
char *logo4 = (char *) "linia_4";
char *logo_uart = (char *) "\r\n AEMC. Counter = ";

unsigned long y, z, x;
unsigned char buff[5];
        
void init_uC(void); 
void interrupt etti(void); 	// functie de intreruperi globala ptr. TOATE intreruperile de pe un 
void init_LCD(void);
void lcd_goto(unsigned char pos);
void lcd_puts(char * s);
void lcd_putch(char c);
void afisare_diacritice(unsigned char diacritic_afisat, unsigned char linia);
void send_string(const char *buffer, int size);
void ultoaa(unsigned long val);

void main(void)
 {
	init_uC();
	init_LCD();
	 
    lcd_goto(0x80);	
    lcd_puts(logo);	 
    lcd_goto(0xC0);	
    lcd_puts(logo2); 
    lcd_goto(0x90);	// 0x94 for 24 characters
    lcd_puts(logo3);	 
//	lcd_goto(0xD4);	
//  lcd_putch(0xdf);
	afisare_diacritice(0, 0xD0);    // 0xD4 for 24 characters
	afisare_diacritice(1, 0xD1);	 
	afisare_diacritice(2, 0xD2);
	afisare_diacritice(3, 0xD3);
	afisare_diacritice(4, 0xD4);
	afisare_diacritice(5, 0xD5);	 
	afisare_diacritice(6, 0xD6);
	afisare_diacritice(7, 0xD7);
	 
	while (1)
	{
        for(y=0; y<70000; y++); 
        send_string(logo_uart, strlen(logo_uart));
        ultoaa(z++);
        send_string(buff, 5);      
        lcd_goto(0xDA);
        lcd_putch('0' + x++);
        if(x>9)x=0;
	}
 }
 
 void init_uC (void) 
{ 
	OSCCON 	= 0x71;			// setez Osc. intern uC de 8MHz // pag. 64
	TRISB 	= 0b00000000;	// tot Portul B este de iesire
	TRISD 	= 0b00000000;	// tot Portul B este de iesire
	ANSEL  = 0x00;
	ANSELH  = 0x00;
	PORTB 	= 0b00000000;	// initializez PORTB cu valori de 0 logic
// do not modify on TRISC  RC6 & RC7
    TRISC = 0b10111111;     // RC7=RX=in || RC6=TX=out        
// do not modify on TRISC  RC6 & RC7  
	OPTION_REG = 0b00000111;// Frecv. intrare T0 = Frecv. Osc./4 (=8MHz/4) = 2MHz
							// prescaler=256 => Frecv. T0 = 2MHz/256 = KHz (sau T=128us)
	TMR0IF 	= 0;			// 
	TMR0 	= 178;	  		// porneste numararea de la valoarea 178; pana la maxim (255) 
	TMR0IE 	= 1;    		// activez intreruperea ptr. T0  
    
    SPBRG = 16;             // Baud Rate (viteza transmisie date)   // 115200bps
    BRGH = 1;               // High Baud Rate Transmission
    BRG16 = 1;              // 16-bit Baud Rate Generator bit    
    SYNC = 0;               // EUSART Mode Select bit [0=Asynchronous mode]    
    TXEN = 1;               // Serial Trasmit Enable
    CREN = 1;               // Continuous Receive Enable bit
    SPEN = 1;               // Serial Port Enabled
    RCIE = 1;               //intrerupere de la portul serial      
    PEIE = 1;
	GIE  = 1;       		// activez Global intreruperile
} 

void interrupt etti(void)	// ajung aici la fiecare 78*128us=~10ms
{       
	if(TMR0IF)				// daca flagul TMR0IF=1
	{
		 TMR0IF = 0;   		// obligatoriu - sterg flagul Timerului care a generat intreruperea
		 TMR0 = 178;  		// 
		 LED2 = !LED2; 		// 
	}

// NU MODIFICATI AICI !!!    
    if(RCIF)            // for boot connection
    {        
        RCIF = 0;       
        asm("ljmp 0");   
    }
// NU MODIFICATI AICI !!!     
}

void send_string(const char *buffer, int size)
{
 while(size)
 {
    TXREG = *buffer;
    while(!TXIF); // TXIF bit is located in PIR1 register // wait until transmission is completed
    for(y=0; y<50; y++);    // to be safe
    buffer++;
    size--;
 }
} 

void ultoaa(unsigned long val)
{
	unsigned char *p;
	unsigned char e;

	for(e=0; e<4; e++)
		{
			buff[e] = '0';
		}

	p = buff+sizeof(buff);
 	do
		{
			*--p = '0' + val%10;
			val/=10;
		}
	while(val);
}